/* ===============================================
  OPEN CLOSE Menu
============================================= */

function personal_tutor_open_menu() {
  jQuery('button.menu-toggle').addClass('close-panal');
  setTimeout(function(){
    jQuery('nav#main-menu').show();
  }, 100);

  return false;
}
jQuery( "button.menu-toggle").on("click", personal_tutor_open_menu);

function personal_tutor_close_menu() {
  jQuery('button.close-menu').removeClass('close-panal');
  jQuery('nav#main-menu').hide();
}

jQuery( "button.close-menu").on("click", personal_tutor_close_menu);

/* ===============================================
  TRAP TAB FOCUS ON MODAL MENU
============================================= */

jQuery('button.close-menu').on('keydown', function (e) {
  if (jQuery("this:focus") && !!e.shiftKey && e.keyCode === 9) {
  } else if (jQuery("this:focus") && (e.which === 9)) {
    e.preventDefault();
    jQuery(this).blur();
    jQuery('.menu li a:first').focus()
  }
});

jQuery('.menu li a:first').on('keydown', function (event) {
  if (jQuery("this:focus") && !!event.shiftKey && event.keyCode === 9) {
    event.preventDefault();
    jQuery(this).blur();
    jQuery('button.close-menu').focus()
  }
});

jQuery('#main-menu ul:first li:first a').on('keydown', function (event) {
  if (event.shiftKey && event.keyCode == 9) {
    event.preventDefault();
    jQuery(this).blur();
    jQuery('button.close-menu').focus();
  }
})

jQuery(document).ready(function() {
  window.addEventListener('load', (event) => {
      jQuery(".loader").delay(2000).fadeOut("slow");
  });
});

jQuery('a[href="#tobottom"]').click(function () {
  jQuery('html, body').animate({scrollTop: 0}, 'slow');
  return false;
});
(function( $ ) {
  $(window).scroll(function(){
      var sticky = $('.sticky-header'),
      scroll = $(window).scrollTop();
      if (scroll >= 100) sticky.addClass('fixed-header');
      else sticky.removeClass('fixed-header');
    });
  })( jQuery );

/* ===============================================
  Scroll Top //
============================================= */

jQuery(window).scroll(function () {
  if (jQuery(this).scrollTop() > 100) {
      jQuery('.scroll-up').fadeIn();
  } else {
      jQuery('.scroll-up').fadeOut();
  }
});



/* ===============================================
  Custom Cursor
============================================= */

const personal_tutor_customCursor = {
  init: function () {
    this.personal_tutor_customCursor();
  },
  isVariableDefined: function (el) {
    return typeof el !== "undefined" && el !== null;
  },
  select: function (selectors) {
    return document.querySelector(selectors);
  },
  selectAll: function (selectors) {
    return document.querySelectorAll(selectors);
  },
  personal_tutor_customCursor: function () {
    const personal_tutor_cursorDot = this.select(".cursor-point");
    const personal_tutor_cursorOutline = this.select(".cursor-point-outline");
    if (this.isVariableDefined(personal_tutor_cursorDot) && this.isVariableDefined(personal_tutor_cursorOutline)) {
      const cursor = {
        delay: 8,
        _x: 0,
        _y: 0,
        endX: window.innerWidth / 2,
        endY: window.innerHeight / 2,
        cursorVisible: true,
        cursorEnlarged: false,
        $dot: personal_tutor_cursorDot,
        $outline: personal_tutor_cursorOutline,

        init: function () {
          this.dotSize = this.$dot.offsetWidth;
          this.outlineSize = this.$outline.offsetWidth;
          this.setupEventListeners();
          this.animateDotOutline();
        },

        updateCursor: function (e) {
          this.cursorVisible = true;
          this.toggleCursorVisibility();
          this.endX = e.clientX;
          this.endY = e.clientY;
          this.$dot.style.top = `${this.endY}px`;
          this.$dot.style.left = `${this.endX}px`;
        },

        setupEventListeners: function () {
          window.addEventListener("load", () => {
            this.cursorEnlarged = false;
            this.toggleCursorSize();
          });

          personal_tutor_customCursor.selectAll("a, button").forEach((el) => {
            el.addEventListener("mouseover", () => {
              this.cursorEnlarged = true;
              this.toggleCursorSize();
            });
            el.addEventListener("mouseout", () => {
              this.cursorEnlarged = false;
              this.toggleCursorSize();
            });
          });

          document.addEventListener("mousedown", () => {
            this.cursorEnlarged = true;
            this.toggleCursorSize();
          });
          document.addEventListener("mouseup", () => {
            this.cursorEnlarged = false;
            this.toggleCursorSize();
          });

          document.addEventListener("mousemove", (e) => {
            this.updateCursor(e);
          });

          document.addEventListener("mouseenter", () => {
            this.cursorVisible = true;
            this.toggleCursorVisibility();
            this.$dot.style.opacity = 1;
            this.$outline.style.opacity = 1;
          });

          document.addEventListener("mouseleave", () => {
            this.cursorVisible = false;
            this.toggleCursorVisibility();
            this.$dot.style.opacity = 0;
            this.$outline.style.opacity = 0;
          });
        },

        animateDotOutline: function () {
          this._x += (this.endX - this._x) / this.delay;
          this._y += (this.endY - this._y) / this.delay;
          this.$outline.style.top = `${this._y}px`;
          this.$outline.style.left = `${this._x}px`;

          requestAnimationFrame(this.animateDotOutline.bind(this));
        },

        toggleCursorSize: function () {
          if (this.cursorEnlarged) {
            this.$dot.style.transform = "translate(-50%, -50%) scale(0.75)";
            this.$outline.style.transform = "translate(-50%, -50%) scale(1.6)";
          } else {
            this.$dot.style.transform = "translate(-50%, -50%) scale(1)";
            this.$outline.style.transform = "translate(-50%, -50%) scale(1)";
          }
        },

        toggleCursorVisibility: function () {
          if (this.cursorVisible) {
            this.$dot.style.opacity = 1;
            this.$outline.style.opacity = 1;
          } else {
            this.$dot.style.opacity = 0;
            this.$outline.style.opacity = 0;
          }
        },
      };
      cursor.init();
    }
  },
};
personal_tutor_customCursor.init();

/* ===============================================
  Progress Bar
============================================= */
const personal_tutor_progressBar = {
  init: function () {
      let personal_tutor_progressBarDiv = document.getElementById("elemento-progress-bar");

      if (personal_tutor_progressBarDiv) {
          let personal_tutor_body = document.body;
          let personal_tutor_rootElement = document.documentElement;

          window.addEventListener("scroll", function (event) {
              let personal_tutor_winScroll = personal_tutor_body.scrollTop || personal_tutor_rootElement.scrollTop;
              let personal_tutor_height =
              personal_tutor_rootElement.scrollHeight - personal_tutor_rootElement.clientHeight;
              let personal_tutor_scrolled = (personal_tutor_winScroll / personal_tutor_height) * 100;
              personal_tutor_progressBarDiv.style.width = personal_tutor_scrolled + "%";
          });
      }
  },
};
personal_tutor_progressBar.init();

/* ===============================================
   sticky copyright
============================================= */

window.addEventListener('scroll', function() {
  var personal_tutor_footer = document.querySelector('.sticky-copyright');
  if (!personal_tutor_footer) return; 

  var personal_tutor_scrollTop = window.scrollY || document.documentElement.scrollTop;

  if (personal_tutor_scrollTop >= 100) {
    personal_tutor_footer.classList.add('active-sticky');
  }
});

/* ===============================================
   sticky sidebar
============================================= */

window.addEventListener('scroll', function () {
  var personal_tutor_sidebar = document.querySelector('.sidebar-sticky');
  if (!personal_tutor_sidebar) return;

  var personal_tutor_scrollTop = window.scrollY || document.documentElement.scrollTop;
  var personal_tutor_windowHeight = window.innerHeight;
  var personal_tutor_documentHeight = document.documentElement.scrollHeight;

  var personal_tutor_isBottom = personal_tutor_scrollTop + personal_tutor_windowHeight >= personal_tutor_documentHeight - 100;

  if (personal_tutor_scrollTop >= 100 && !personal_tutor_isBottom) {
    personal_tutor_sidebar.classList.add('sidebar-fixed');
  } else {
    personal_tutor_sidebar.classList.remove('sidebar-fixed');
  }
});